<?php
// REGISTER GRID BLOCK
include_once(GG_DIR .'/settings/field_options.php');



// collections array array (use full list for now)
$collections = get_terms('gg_collections', 'hide_empty=0');

$colls = array(); 
foreach($collections as $collection) {
	$colls[ $collection->term_id ] = $collection->name;
}



/////////////////////////////////////////////



// structure
$defaults = array(
	'cid' => array(
		'label'		=> __('Which collection?', GG_ML),
		'type'		=> 'select',
		'opts'		=> $colls,
		'default' 	=> current(array_keys($colls)),
		'panel'		=> 'main',
	),
	'filter' => array(
		'label'		=> __('Use tags filter?', GG_ML),
		'type'		=> 'checkbox',
		'default' 	=> '',
		'panel'		=> 'main',
	),
	'random' => array(
		'label'		=> __('Random display?', GG_ML),
		'type'		=> 'checkbox',
		'default' 	=> '',
		'panel'		=> 'main',
	),
	'pag_sys' => array(
		'label'		=> __('Pagination system', GG_ML),
		'type'		=> 'select',
		'opts'		=> array(
			'' 		=> __('None', GG_ML),
			'auto' 	=> __('Auto - follow global settings', GG_ML)
			) + gg_pag_sys(),
		'default' 	=> '',
		'panel'		=> 'main',
	),
	'per_page' => array(
		'label'		=> __('How many galleries per page?', GG_ML),
		'type'		=> 'slider',
		'min'		=> 0,
		'max'		=> 200,
		'default' 	=> 0,
		'panel'		=> 'main',
		
		'condition' => array(
			'pag_sys' => array(
				'!=', 
				array('')
			)
		)
	),
	'overlay' => array(
		'label'		=> __('Overlay', 'mg_ml'),
		'type'		=> 'select',
		'opts'		=> $GLOBALS['ggom_guten_ols'],
		'default' 	=> current(array_keys($GLOBALS['ggom_guten_ols'])),
		'panel'		=> 'main',
	),
);



register_block_type('lcweb/g-collection', array(
	'editor_script' 	=> 'gg_coll_on_guten',
	'render_callback' 	=> 'gg_collection_guten_handler',
	'attributes' 		=> $defaults
));



wp_localize_script('wp-blocks', 'gg_coll_defaults', $defaults);
