<?php
// WRAPPING UP BUILDER BOXES


// register boxes
function gg_gall_builder_metaboxes() {
	add_meta_box('submitdiv', __('Publish', GG_ML), 'post_submit_meta_box', 'gg_galleries', 'side', 'high');


	// SIDEBOXES
	include_once('side_boxes.php');
	add_meta_box('gg_gb_gallery_type', __('Gallery Type', GG_ML), 'gg_gb_gallery_type', 'gg_galleries', 'side', 'core');
	
	add_meta_box('gg_gb_main_settings', __('Main Settings', GG_ML) .'<span class="dashicons dashicons-info gg_gb_meta_infobox" title="'. esc_attr(__('Use "default" option or leave fields empty to use global setup', GG_ML)) .'"></span>', 'gg_gb_main_settings', 'gg_galleries', 'side', 'core');
	
	add_meta_box('gg_gb_sitemap', __('Page URL for sitemap', GG_ML) .'<span class="dashicons dashicons-info gg_gb_meta_infobox" title="'. esc_attr(__('Insert the page URL where the gallery will be placed', GG_ML)) .'"></span>', 'gg_gb_sitemap', 'gg_galleries', 'side', 'low');

	if(filter_var(get_option('gg_watermark_img'), FILTER_VALIDATE_URL)) {
		add_meta_box('gg_gb_wmark_cache', __('Watermark Cache', GG_ML), 'gg_gb_wmark_cache', 'gg_galleries', 'side', 'low');
	}



	
	// BUILDER
	add_meta_box('gg_specific_settings', __('Specific Settings', GG_ML), 'gg_specific_settings', 'gg_galleries', 'normal', 'default');
	add_meta_box('gg_gallery_builder', __('Gallery Builder', GG_ML), 'gg_gallery_builder', 'gg_galleries', 'normal', 'default');
}
add_action('admin_init', 'gg_gall_builder_metaboxes');



// SAVE
include_once('ajax.php');
include_once('save.php');








//////////////////////////
// GALLERY SPECIFIC SETTINGS
function gg_specific_settings() {
	include_once(GG_DIR . '/classes/gg_builder_sources_hub.php');
	global $post;
	?>
    <div class="lcwp_mainbox_meta">
    	<div id="gg_settings_wrap">
			<?php
            $hub = new gg_builder_hub($post->ID, get_post_meta($post->ID, 'gg_type', true) );
            echo $hub->spec_opt();
            ?>
        </div>
    </div>
    <?php
}







//////////////////////////
// GALLERY BUILDER
function gg_gallery_builder() {
	include_once(GG_DIR . '/classes/gg_connections_hub.php');
	
	global $post;
	$conn_hub = new gg_connection_hub($post->ID);
	
	$type 		= get_post_meta($post->ID, 'gg_type', true);
	$autopop 	= get_post_meta($post->ID, 'gg_autopop', true);
	?>
    
    <div class="lcwp_mainbox_meta">
    	<div id="gg_builder_wrap">
		<?php
		
		// MANUAL GALLERY
		if($autopop != '1') {
			$gallery = gg_gall_data_get($post->ID);

			// picked images gallery
			if(empty($gallery)) {
				echo '<em>'. __('Select images source', GG_ML) .'</em>';
			}
			else {
				echo '
				<table class="widefat lcwp_table lcwp_metabox_table">
				  <thead>
				  <tr>
					<th>
						<div id="gg_bulk_opt_wrap" style="display: none;"></div>
					</th>
				  </tr>
				  </thead>
				</table>
				<ul id="gg_fb_builder">';

				if(!is_array($gallery)) {
					$gallery = array();
				}
				foreach($gallery as $item) {
					$tags 		= (isset($item['tags'])) ? $item['tags'] : '';
					$link_opt 	= (isset($item['link_opt'])) ? $item['link_opt'] : 'none';
					$link_val 	= (isset($item['link'])) ? $item['link'] : '';

					$img_full_src = gg_img_src_on_type($item['img_src'], $type);
					$img_full_url = gg_img_url_on_type($item['img_src'], $type, true);

					if(in_array($type, array('wp', 'wp_cat', 'cpt_tax', 'rml'))) { // use WP thumbs					
						$thumb_data = wp_get_attachment_image_src($item['img_src'], array(400, 0));
						$thumb = $thumb_data[0];
					} 
					else {
						$thumb = (!get_option('gg_use_admin_thumbs')) ? $img_full_url : gg_thumb_src($img_full_src, $width = 400, false, 85, $alignment = $item['thumb'], 3);
					}
					
					echo '<li>
						<div class="gg_sm_handler lcwp_move_row"></div>
						<div class="gg_cmd_bar">
							<div class="lcwp_row_to_sel" title="'. __('select image', GG_ML) .'"></div>
							<div class="lcwp_del_row" title="'. __('remove image', GG_ML) .'"></div>
							<div class="gg_sel_thumb" title="'. __("set thumbnail's center", GG_ML) .'">
								<input type="hidden" name="gg_item_thumb[]" value="'.gg_sanitize_input($item['thumb']).'" class="gg_item_thumb" />
							</div>
							<div class="gg_enlarge_img" title="'. __('enlarge image', GG_ML) .'"></div>
						</div>
						<div class="gg_builder_img_wrap">
							<figure style="background-image: url('.$thumb.');" class="gg_builder_img" fullurl="'.gg_sanitize_input($img_full_url).'" title="'. __("click to enlarge", GG_ML) .'"></figure>
							<input type="hidden" name="gg_item_img_src[]" value="'.gg_sanitize_input($item['img_src']).'" class="gg_item_img_src" />
						</div>
						<div class="gg_img_texts">
							<table>
							  <tr>
								<td class="gg_img_data_icon"><img src="'.GG_URL.'/img/photo_author.png" title="photo author" /></td>
								<td><input type="text" name="gg_item_author[]" value="'.gg_sanitize_input($item['author']).'" class="gg_item_author" autocomplete="off" /></td>
							  </tr>
							  <tr>
								<td class="gg_img_data_icon"><img src="'.GG_URL.'/img/photo_title.png" title="photo title" /></td>
								<td><input type="text" name="gg_item_title[]" value="'.gg_sanitize_input($item['title']).'" class="gg_item_title" autocomplete="off" /></td>
							  </tr>
							  <tr>
								<td class="gg_img_data_icon"><img src="'.GG_URL.'/img/photo_descr.png" title="photo description" /></td>
								<td><textarea name="gg_item_descr[]" class="gg_item_descr" autocomplete="off">'.gg_sanitize_input(preg_replace('/<br\s*\/?>/', '
', $item['descr'])).'</textarea></td>
							  </tr>
							  <tr>
								<td class="gg_img_data_icon"><img src="'.GG_URL.'/img/tags_icon.png" title="photo tags - comma split" /></td>
								<td><textarea name="gg_item_tags[]" class="gg_item_tags" autocomplete="off">'.gg_sanitize_input($tags).'</textarea></td>
							  </tr>
							  <tr>
								<td class="gg_img_data_icon"><img src="'.GG_URL.'/img/link_icon.png" title="photo link" /></td>
								<td>
									<select name="gg_link_opt[]" class="gg_linking_dd" autocomplete="off">
										<option value="none">'. __('No link', GG_ML) .'</option>
										<option value="page" '; if($link_opt == 'page') {echo 'selected="selected"';} echo '>'. __('To a page', GG_ML) .'</option>
										<option value="custom" '; if($link_opt == 'custom') {echo 'selected="selected"';} echo '>'. __('Custom link', GG_ML) .'</option>
									</select>
									<div class="gg_link_wrap">'.gg_link_field($link_opt, $link_val).'</div>
								</td>
							  </tr>
							</table>
						</div>
					</li>';
				}

				echo '</ul>';
			}
		}



		// AUTO POPULATED GALLERY
		else {
			$gallery = gg_gall_data_get($post->ID, true);

			if(empty($gallery)) {
				echo '<em>'. __('No images found', GG_ML) .' .. </em>';
			}
			else {
				echo '<ul id="gg_fb_builder" class="gg_autopop_gallery">';

				foreach($gallery as $img) {
					$img_full_src = gg_img_src_on_type($img['img_src'], $type);
					$img_full_url = gg_img_url_on_type($img['img_src'], $type);

					if(in_array($type, array('wp', 'wp_cat', 'cpt_tax', 'rml'))) { // use WP thumbs
						$thumb_data = wp_get_attachment_image_src($item['img_src'], 'medium_large');
						$thumb = $thumb_data[0];
					} else {
						$thumb = (!get_option('gg_use_admin_thumbs')) ? $img_full_url : gg_thumb_src($img_full_src, $width = 400, false, 'c', 3);
					}
					
					echo '<li>
						<div class="gg_builder_img_wrap">
							<figure style="background-image: url('.$thumb.');" class="gg_builder_img" fullurl="'.gg_sanitize_input($img_full_url).'" title="'. __("click to enlarge", GG_ML) .'"></figure>
						</div>
						<div class="gg_img_texts">
							<table>
							  <tr>
								<td class="gg_img_data_icon"><img src="'.GG_URL.'/img/photo_author.png" title="photo author" /></td>
								<td>'.gg_sanitize_input($img['author']).'</td>
							  </tr>
							  <tr>
								<td class="gg_img_data_icon"><img src="'.GG_URL.'/img/photo_title.png" title="photo title" /></td>
								<td>'.gg_sanitize_input($img['title']).'</td>
							  </tr>
							  <tr>
								<td class="gg_img_data_icon"><img src="'.GG_URL.'/img/photo_descr.png" title="photo description" /></td>
								<td>'.gg_sanitize_input($img['descr']).'</td>
							  </tr>';
				  
							  if(($type == 'wp_cat' || $type == 'cpt_tax') && isset($img['link']) && !empty($img['link'])) {
								echo '
								<tr>
									<td class="gg_img_data_icon"><img src="'.GG_URL.'/img/link_icon.png" title="photo link" /></td>
									<td style="position: relative;"><a href="'. $img['link'] .'" target="_blank">'. $img['link'] .'</a></td>
								</tr>';
							  }
							
							echo '
							</table>
						</div>
					</li>';
				}

				echo '</ul>';
			}
		}
        ?>
        </div>
    </div>




    <?php // hidden code to set thumbs center ?>
    <div id="gg_set_thumb_center" style="display: none;">
    	<h4><?php _e('Select thumbnail center clicking on a cell', GG_ML) ?>:</h4>
        <table class="gg_sel_thumb_center">
            <tr>
                <td id="gg_tl"></td>
                <td id="gg_t"></td>
                <td id="gg_tr"></td>
            </tr>
            <tr>
                <td id="gg_l"></td>
                <td id="gg_c"></td>
                <td id="gg_r"></td>
            </tr>
            <tr>
                <td id="gg_bl"></td>
                <td id="gg_b"></td>
                <td id="gg_br"></td>
            </tr>
        </table>
    </div>



 	<?php // hidden bulk cmd code ?>
	<div id="gg_bulk_cmd_code_wrap" style="display: none;">
    	<label style="padding-right: 5px; margin-bottom: -4px;"><?php esc_html_e('Bulk Options', GG_ML) ?></label>
        
        <select data-placeholder="<?php esc_html_e('Select an option', GG_ML) ?> .." id="gg_bulk_opt">
            <option value="remove"><?php esc_html_e('Remove Images', GG_ML) ?></option>
            <option value="author"><?php esc_html_e('Set Author', GG_ML) ?></option>
            <option value="title"><?php esc_html_e('Set Title', GG_ML) ?></option>
            <option value="descr"><?php esc_html_e('Set Description', GG_ML) ?></option>
            <option value="thumb"><?php esc_html_e('Set Thumbnail Center', GG_ML) ?></option>
        </select>
        
        <input type="text" value="" id="gg_bulk_val" style="margin-left: 15px; display: none;" />
        
        <span id="gg_bulk_thumb_wrap" style="padding-left: 20px; display: none;">
            <select data-placeholder="<?php esc_html_e('Select an option', GG_ML) ?> .." id="gg_bulk_thumb_val">
                <option value="tl"><?php esc_html_e('Top-left', GG_ML) ?></option>
                <option value="t"><?php esc_html_e('Top', GG_ML) ?></option>
                <option value="tr"><?php esc_html_e('Top-right', GG_ML) ?></option>
                <option value="l"><?php esc_html_e('Left', GG_ML) ?></option>
                <option value="c"><?php esc_html_e('Center', GG_ML) ?></option>
                <option value="r"><?php esc_html_e('Right', GG_ML) ?></option>
                <option value="bl"><?php esc_html_e('Bottom-left', GG_ML) ?></option>
                <option value="b"><?php esc_html_e('Bottom', GG_ML) ?></option>
                <option value="br"><?php esc_html_e('Bottom-right', GG_ML) ?></option>
            </select>
        </span>
        
        <input type="button" value="<?php esc_html_e('Apply', GG_ML) ?>" id="gg_bulk_perform" class="button-secondary" />
    </div>




    <?php // ////////////////////// ?>



    <?php // SCRIPTS ?>
	<script src="<?php echo GG_URL; ?>/js/functions.js" type="text/javascript"></script>
    <script src="<?php echo GG_URL; ?>/js/chosen/chosen.jquery.min.js" type="text/javascript"></script>
    <script src="<?php echo GG_URL; ?>/js/lc-switch/lc_switch.min.js" type="text/javascript"></script>
    
    <script src="<?php echo GG_URL; ?>/js/jquery.event.drag-2.2/jquery.event.drag-2.2.js" type="text/javascript"></script>
    <script src="<?php echo GG_URL; ?>/js/jquery.event.drag-2.2/jquery.event.drag.live-2.2.js" type="text/javascript"></script>
    <script src="<?php echo GG_URL; ?>/js/jquery.event.drop-2.2/jquery.event.drop-2.2.js" type="text/javascript"></script>
    <script src="<?php echo GG_URL; ?>/js/jquery.event.drop-2.2/jquery.event.drop.live-2.2.js" type="text/javascript"></script>

	<link rel="stylesheet" href="<?php echo GG_URL; ?>/js/lightboxes/lc-lightbox/css/lc_lightbox.min.css" type="text/css" media="all" />
    <link rel="stylesheet" href="<?php echo GG_URL; ?>/js/lightboxes/lc-lightbox/skins/light.css" type="text/css" media="all" />
	<script src="<?php echo GG_URL; ?>/js/lightboxes/lc-lightbox/js/lc_lightbox.gg.min.js" type="text/javascript"></script>
	
	<style type="text/css">
	/* LC-LIGHTBOX - zoom-in effect */
	.lcl_zoomin_oc.lcl_pre_show #lcl_window,
	.lcl_zoomin_oc.lcl_is_closing #lcl_window {
		opacity: 0 !important;
		
		-webkit-transform: scale(0.05) translateZ(0) !important;
		transform: scale(0.05) translateZ(0) !important;		
	}
	.lcl_zoomin_oc.lcl_is_closing #lcl_overlay {
		opacity: 0 !important;
	}
	</style>
	
    
    
    <script type="text/javascript">
	jQuery(document).ready(function($) {
		gg_nonce = '<?php echo wp_create_nonce('gg_gall_builder') ?>';
		
		// First init - gallery settings & builder load
		var gid 		= <?php echo $post->ID; ?>; 
		var TT_url 		= '<?php echo GG_TT_URL ?>';
		var EWPT_url 	= '<?php echo GG_EWPT_URL ?>';
		var gg_use_tt 	= <?php echo (get_option('gg_use_timthumb')) ? 'true' : 'false'; ?>;
		var gg_erase_past = false; // flag reporting whether a gallery cleaning is needed (eg. changing source)
	
		// encapsulate ajax objects to abort them in case and save server resources 
		var spec_opt_ajax = false;
		var img_picker_ajax = false;
		
		
		// basic gallery data handle
		var gg_basic_data = function() {
			$ = jQuery; // dunno why, but with some customers it's needed
			
			gg_type 	= $('#gg_type_dd').val();
			gg_username = $('#gg_username').val();
			gg_psw 		= $('#gg_psw').val();
		}
		
		
		// get the additional vars depending on the type
		var get_type_extra = function() {
			switch(gg_type) {
				
				case 'wp_cat' : 
					return $('#gg_wp_cat').val();
				
				case 'cpt_tax' : 
					return { 
						cpt_tax : $('#gg_cpt_tax').val(), 
						term 	: $('#gg_cpt_tax_term').val() 
					};
					
				case 'gg_album' : 
					return $('#gg_album').val();
					
				case 'g_drive' : 
					return $('#gg_gdrive_album').val();
					
				case 'onedrive' : 
					return $('#gg_onedrive_album').val();
					
				case 'rml' : 
					return $('#gg_rml_folder').val();
				
				case 'ngg' : 
					return $('#gg_ngg_gallery').val();
					
				default :
					return '';	
			}
		}
	
	

		// init fetching data and starting images picker
		var gg_gallery_init = function(on_builder_opening) {
			gg_basic_data();
			
			if(typeof(on_builder_opening) == 'undefined') {
				gg_load_settings();	
			}
			else {
				gg_load_img_picker(1);	
			}
		}
		
	
		// gallery settings display
		var gg_load_settings = function() {
			if(spec_opt_ajax !== false) {spec_opt_ajax.abort();}
			$('#gg_settings_wrap').html('<div style="height: 30px;" class="lcwp_loading"></div>');
	
			var data = {
				action		: 'gg_load_gb_settings',
				gallery_id	: gid,
				gg_type		: gg_type,
				gg_username	: gg_username,
				gg_connect_id: ($('#gg_connect_id').length) ? $('#gg_connect_id').val() : false,
				gg_psw		: gg_psw,
				nonce		: gg_nonce,
			};
	
			spec_opt_ajax = $.post(ajaxurl, data, function(response) {
				$('#gg_settings_wrap').html(response);
				gg_live_chosen();
				gg_ip_checks();
				
				spec_opt_ajax = false;
				gg_load_img_picker(1);
			});
	
			return true;
		}
		
		
		// images picker
		var gg_img_pp = 26;
		var gg_sel_img = [];
	
		
		// img selection with mouse drag
		var gg_sel_img_on_drag = function() {
			if($('.gg_all_img').length > 2) {
				$('#gg_img_picker_area').drag("start",function( ev, dd ){
					return $('<div id="gg_drag_selection" />')
						.css('opacity', .45 )
						.appendTo( document.body );
				})
				.drag(function( ev, dd ){
					$( dd.proxy ).css({
						top: Math.min( ev.pageY, dd.startY ),
						left: Math.min( ev.pageX, dd.startX ),
						height: Math.abs( ev.pageY - dd.startY ),
						width: Math.abs( ev.pageX - dd.startX )
					});
				})
				.drag("end",function( ev, dd ){
					$( dd.proxy ).remove();
					gg_man_img_array();
				});
	
				$('#gg_img_picker ul li')
					.drop(function( ev, dd ){
						if(!$(this).hasClass('gg_img_inserted')) {
							$(this).toggleClass('gg_img_sel');
						}
					})
				$.drop({ multi: true });
			}
		};
	
	
		// load images picker
		var gg_load_img_picker = function(page) {
			if(img_picker_ajax !== false) {img_picker_ajax.abort();}
			
			$('#gg_img_picker').html('<div style="height: 30px;" class="lcwp_loading"></div>');
			
			var data = {
				action		: 'gg_img_picker',
				gg_type		: gg_type,
				page		: page,
				per_page	: gg_img_pp,
				gallery_id	: gid,
				gg_search	: ($('.gg_img_search').length) ? $('.gg_img_search').val() : '',
				gg_extra	: get_type_extra(),
				nonce		: gg_nonce,
			};
	
			img_picker_ajax = $.post(ajaxurl, data, function(response) {
				$('#gg_img_picker').html(response);
				gg_sel_img_on_drag();
				gg_sel_picker_img_status();
				
				img_picker_ajax = false;
			});
	
			return true;
		};
	
	
	
		// display added images count 
		var gg_count_gall_images = function() {
			if(!$('#gg_gallery_builder .gg_gb_h2 small').length) {
				$('#gg_gallery_builder .gg_gb_h2').append('<small></small>');	
			}
			var $subj = $('#gg_gallery_builder .gg_gb_h2 small');
			var tot = $('#gg_fb_builder > li').length;
			
			
			if(!tot) {
				$subj.empty();	
			} else {
				$subj.html(' ('+ tot  +' <?php _e('images', GG_ML) ?>)');	
			}
		};
		
	
	
		/////////
		// initialize engine
		gg_gallery_init(true);
		gg_count_gall_images();
		

		// update on gallery type change
		$(document).delegate('#gg_type_dd', 'change', function(e) {
			if($('#gg_fb_builder').length && !confirm("<?php _e('Current gallery will be erased. Continue?', GG_ML) ?>")) {
				return false;	
			}
			
			var gg_new_type = $(this).val();
			
			gg_erase_past = 1;
			gg_reset_gallery();
			
			// init gallery if source doesn't require config
			if( $.inArray(gg_new_type, ['wp', 'wp_cat', 'cpt_tax', 'gg_album', 'rml', 'ngg']) !== -1 ) {
				gg_gallery_init();
				
				$('#gg_connect_id_wrap, #gg_username_wrap, #gg_psw_wrap, #gg_handle_user_btn').slideUp();
				return false;
			}


			// connection hub toggle
			if($.inArray(gg_new_type, ['<?php echo implode("','", $conn_hub->to_consider) ?>']) !== -1) {
				$('#gg_connect_id_wrap').slideDown();
				gg_reload_conn_hub_dd();	
			} else {
				$('#gg_connect_id_wrap').slideUp();
			}
			
			////////////////////////////////////////////
			
							
			// change username label
			switch(gg_new_type) {
				case 'flickr'	: $('#gg_username_wrap label').text('<?php esc_html_e('Set / Profile / Tag URL', GG_ML) ?>'); break;
				case 'pinterest': $('#gg_username_wrap label').text('<?php esc_html_e('Board URL', GG_ML) ?>'); break;
				case 'instagram': $('#gg_username_wrap label').text('<?php esc_html_e('Profile URL', GG_ML) ?>'); break;
				case 'g_drive'	: $('#gg_username_wrap label').text('<?php esc_html_e('Public folder URL', GG_ML) ?>'); break;
				case 'twitter'	: $('#gg_username_wrap label').text('<?php esc_html_e('@Username or #hashtag', GG_ML) ?>'); break;
				case 'tumblr'	: $('#gg_username_wrap label').text('<?php esc_html_e('Blog URL', GG_ML) ?>'); break;
				case 'rss'		: $('#gg_username_wrap label').text('<?php esc_html_e('Feed URL', GG_ML) ?>'); break;
				default			: $('#gg_username_wrap label').text('<?php esc_html_e('Username', GG_ML) ?>'); break;
			}

			//// gallery type auth data toggle
			// reset fields
			if(gg_type != gg_new_type) {
				$('#gg_username_wrap input, #gg_psw_wrap input').val('');
			}
			
			
			// username field visibility
			if( $.inArray(gg_new_type, ['<?php echo  implode("','", array_merge($conn_hub->to_consider, array('wp', 'wp_cat', 'cpt_tax', 'gg_album', 'rml', 'ngg'))) ?>']) === -1 ) {
				$('#gg_username_wrap').slideDown();
			} else {
				$('#gg_username_wrap').slideUp();
			}
			

			// connect button visibility
			if( $.inArray(gg_new_type, ['wp', 'wp_cat', 'cpt_tax', 'gg_album', 'rml', 'ngg']) === -1 ) {
				$('#gg_handle_user_btn').slideDown();
			} else {
				$('#gg_handle_user_btn').slideUp();
			}
		});
		
		// start on "connect" button click
		$(document).delegate('#gg_handle_user_btn', 'click', function() {
			if( !$('#gg_fb_builder').length || ( $('#gg_fb_builder').length && confirm("<?php echo _e('Current gallery will be erased. Continue?', GG_ML) ?>") ) ) {
			
				gg_erase_past = 1;
				gg_reset_gallery();
				gg_gallery_init();
			}
		});
	
	
	
		
		// block standard WP post saving to save images asynchronously - only for manual galleries
		var gg_saved_manual_gallery = false;
		$('#post').on('submit', function(e) {
			if($('[name=gg_autopop]').is(':checked') || gg_saved_manual_gallery) {
				return true;	
			}
			
			e.preventDefault();
			$('#publishing-action .spinner').css('visibility', 'visible');
			
			// store gallery data into a JSON string to be as compact as possible through ajax
			var gdata = {
				gg_item_img_src : [],
				gg_item_thumb 	: [],
				gg_item_author 	: [],
				gg_item_title 	: [],
				gg_item_descr 	: [],
				gg_item_tags 	: [],
				gg_link_opt 	: [],
				gg_item_link 	: [],
			};
			$('#gg_fb_builder li').each(function() {
                
				gdata.gg_item_img_src.push(		$(this).find('.gg_item_img_src').val());
				gdata.gg_item_thumb.push(		$(this).find('.gg_item_thumb').val());
				gdata.gg_item_author.push(		$(this).find('.gg_item_author').val());
				gdata.gg_item_title.push(		$(this).find('.gg_item_title').val());
				gdata.gg_item_descr.push(		$(this).find('.gg_item_descr').val());
				gdata.gg_item_tags.push(		$(this).find('.gg_item_tags').val());
				gdata.gg_link_opt.push(			$(this).find('.gg_linking_dd').val());
				gdata.gg_item_link.push(		$(this).find('.gg_link_field').val());
            });
			
			var data = {
				action 	: 'gg_manual_gb_save',
				gid		: gid,
				nonce	: gg_nonce,
				gdata 	: JSON.stringify(gdata),
			};
			$.post(ajaxurl, data, function(response) {
				
				if($.trim(response) == 'success') {
					
					// disable fields to avoid the same problem
					$('#gg_fb_builder li').find('input, select, textarea').prop('disabled', 'disabled');
					
					gg_saved_manual_gallery = true;
					$('#publish').trigger('click');
				}
				else {
					alert(response);
					$('#publishing-action .spinner').css('visibility', 'hidden');	
				}
			});
	
			return false;
		});
		
		
		
		
		// reset gallery
		var gg_reset_gallery = function() {
			$('#gg_settings_wrap').html('<em><?php echo esc_attr( __('Select gallery type and fill in data to get images', GG_ML)) ?></em>');
			$('#gg_builder_wrap').html('<em><?php echo esc_attr( __('Select images source', GG_ML)) ?></em>');
	
			$('#gg_gallery_builder > h3 small').remove();
		}
	
	
	
	
		/////////////////////////////////////
	
	
	
	
		////////////////////////
		// gallery management
	
		// add selected images to the gallery
		$(document).delegate('#gg_add_img', 'click', function() {
			if( !$('#gg_builder_wrap > ul').length ) {
				$('#gg_builder_wrap').html('\
					<table class="widefat lcwp_table lcwp_metabox_table">\
					  <thead><tr>\
						  <th><div id="gg_bulk_opt_wrap" style="display: none;"></div></th>\
					  </tr></thead>\
					</table>\
					<ul id="gg_fb_builder"></ul>');
			}
	
			// revert array to add in right order
			gg_sel_img.reverse();
	
			$.each(gg_sel_img, function(index, value) {
				var img_id = value.substr(4);
				var $img = $('#'+img_id);
				
				var img_url = $img.attr('fullurl');
	
				var img_full_src = encodeURIComponent( $img.attr('img_full_src') );
				var img_src = $('#'+img_id).attr('img_src');
	
				var author = $img.attr('author');
				var title  = $img.attr('title');
				var descr  = $img.attr('alt').replace(/<br\s*\/?>/gi, '\n');
	
				var base_script = (gg_use_tt) ? TT_url : EWPT_url;
				var thumb_url = <?php echo (!get_option('gg_use_admin_thumbs')) ? 'img_url' : "base_script +'?src='+img_full_src+'&w=400&h=&q=85&rs=3&zc=3'"; ?>;
	
				var new_tr = 
				'<li id="'+img_id+'">\
					<div class="gg_sm_handler lcwp_move_row"></div>\
					<div class="gg_cmd_bar">\
						<div class="lcwp_row_to_sel"></div>\
						<div class="lcwp_del_row"></div>\
						<div class="gg_sel_thumb" title="set the thumbnail center">\
							<input type="hidden" name="gg_item_thumb[]" value="c" class="gg_item_thumb" />\
						</div>\
						<div class="gg_enlarge_img" title="enlarge image"></div>\
					</div>\
					<div class="gg_builder_img_wrap">\
						<figure style="background-image: url('+ thumb_url +');" class="gg_builder_img" fullurl="'+img_url+'"></figure>\
						<input type="hidden" name="gg_item_img_src[]" value="'+img_src+'" class="gg_item_img_src" />\
					</div>\
					<div class="gg_img_texts">\
						<table>\
						  <tr>\
							<td class="gg_img_data_icon"><img src="<?php echo GG_URL ?>/img/photo_author.png" title="photo author" /></td>\
							<td><input type="text" name="gg_item_author[]" value="'+author+'" class="gg_item_author" autocomplete="off" /></td>\
						  </tr>\
						  <tr>\
							<td class="gg_img_data_icon"><img src="<?php echo GG_URL ?>/img/photo_title.png" title="photo title" /></td>\
							<td><input type="text" name="gg_item_title[]" value="'+title+'" class="gg_item_title" autocomplete="off" /></td>\
						  </tr>\
						  <tr>\
							<td class="gg_img_data_icon"><img src="<?php echo GG_URL ?>/img/photo_descr.png" title="photo description" /></td>\
							<td><textarea name="gg_item_descr[]" class="gg_item_descr" autocomplete="off">'+descr+'</textarea></td>\
						  </tr>\
						  <tr>\
							<td class="gg_img_data_icon"><img src="<?php echo GG_URL ?>/img/tags_icon.png" title="photo tags - comma split" /></td>\
							<td><textarea name="gg_item_tags[]" class="gg_item_tags" autocomplete="off"></textarea></td>\
						  </tr>\
						  <tr>\
							<td class="gg_img_data_icon"><img src="<?php echo GG_URL ?>/img/link_icon.png" title="photo link" /></td>\
							<td><select name="gg_link_opt[]" class="gg_linking_dd" autocomplete="off">\
									<option value="none"><?php esc_html_e('No link', GG_ML) ?></option>\
									<option value="page"><?php  esc_html_e('To a page', GG_ML) ?></option>\
									<option value="custom"><?php esc_html_e('Custom link', GG_ML) ?></option>\
								</select>\
								<div class="gg_link_wrap"><?php echo gg_link_field('none') ?></div>\
							</td>\
						</table>\
					</div>\
				</li>';
	
				$('#gg_fb_builder').prepend( new_tr );
				
				
				// has got link? add it!
				if($img.attr('link')) {
					$('#gg_fb_builder #'+img_id +' .gg_linking_dd option[value="custom"]').attr('selected', 'selected');	
					$('#gg_fb_builder #'+img_id +' .gg_linking_dd').trigger('change');
					$('#gg_fb_builder #'+img_id +' .gg_link_field').val( $img.attr('link') );
				}
			});
	
			$('#gg_img_picker ul li.gg_img_sel').removeClass('gg_img_sel');
			$('#gg_img_picker ul li.selected').removeClass('selected');
			$('#gg_add_img').fadeOut();
	
			gg_sel_picker_img_status();
			gg_items_sort();
			gg_count_gall_images();
			gg_read_imgs_data();
			
			$('textarea.gg_item_descr').gg_auto_h_textarea();
			$('textarea.gg_item_tags').gg_auto_h_textarea(true);
		});
	
	
		// sortable images 
		var gg_items_sort = function() {
			$('#gg_fb_builder').sortable({
				placeholder: {
					element: function(currentItem) {
						if(!gg_sort_mode_on) {
							return $('<li style="border-color: transparent; border-style: solid; border-width: 0 15px 20px; background-color: #97dd52; height: 350px; margin-bottom: -133px;"></li>')[0];
						} else {
							return $('<li id="gg_builder_sm_placeh"></li>')[0];
						}
					},
					update: function(container, p) {
						return;
					}
				},
				tolerance	: 'intersect',
				handle		: '.gg_builder_img, .gg_sm_handler',
				items		: 'li',
				opacity		: 0.9,
				scrollSensivity: 50,
				create		: function() {
					$("#gg_fb_builder table input, #gg_fb_builder table textarea").bind('mousedown.ui-disableSelection selectstart.ui-disableSelection', function(e) {
					  e.stopImmediatePropagation();
					});
				},
				stop : function () {
					$("#gg_fb_builder table input, #gg_fb_builder table textarea").bind('mousedown.ui-disableSelection selectstart.ui-disableSelection', function(e) {
					  e.stopImmediatePropagation();
					});
				}
			});
		};
		gg_items_sort();
	
	
	
		// rows select
		$(document).delegate('.lcwp_row_to_sel', 'click', function() {
			$(this).toggleClass('lcwp_sel_row');
			$(this).parent().parent().toggleClass('selected');
			gg_bulk_opt();
		});
		
		
		
		// remove item
		$(document).delegate('.gg_cmd_bar .lcwp_del_row', 'click', function() {
			if(confirm("<?php _e('Remove image?', GG_ML) ?>")) {
				$(this).parent().parent().fadeOut(function() {
					$(this).remove();
					gg_sel_picker_img_status();
					gg_count_gall_images();
				});
			}
		});
	
		
		
		
		///////////////////////////////////////////////////
		
		
		
		
		// EASY SORTING MODE
		//// append button - wait a bit to let images counter and bulk selection to be added
		setTimeout(function() {
			$('#gg_gallery_builder .gg_gb_h2').append('<a href="javascript:void(0)" id="gg_sort_mode"><?php esc_html_e('Easy sorting', GG_ML) ?> <span id="gg_sm_flag" class="off">OFF</span></a>');	
			if( $('#gg_autopop input').is(':checked') ) {
				$('#gg_sort_mode').hide();
			}
		}, 200);
		
		gg_sort_mode_on = false;
		
		// manage sorting mode toggle
		$(document).delegate('#gg_sort_mode', 'mousedown', function(e) {
			e.stopImmediatePropagation();
			
			if( !$(this).hasClass('gg_esm_on') ) {
				$('#gg_fb_builder').addClass('gg_is_sorting');
				$(this).addClass('gg_esm_on');
				
				$('#gg_sm_flag').text('ON');
				gg_sort_mode_on = true;
			}
			else {
				$('#gg_fb_builder').removeClass('gg_is_sorting');
				$(this).removeClass('gg_esm_on');
				
				$('#gg_sm_flag').text('OFF');
				gg_sort_mode_on = false;
			}
		});
		
	
	
	
		/////////////////////////////////////////////////////
	
	
	
	
		// BULK CONTROLS
		$('#gg_gallery_builder').removeClass('closed');
		$('#gg_gallery_builder h2').removeClass('hndle').addClass('gg_gb_h2');
		$('#gg_gallery_builder .handlediv').hide();
		
		setTimeout(function() {
			$('#gg_gallery_builder .gg_gb_h2').off('click');
		}, 6000);
		
		
			
		//// append button - wait a bit to let images counter to act 
		setTimeout(function() {
			$('#gg_gallery_builder .gg_gb_h2').append('<a href="javascript:void(0)" id="gg_select_all_img"><?php esc_html_e('Select all', GG_ML) ?></a>');	
			if( $('#gg_autopop input').is(':checked') ) {
				$('#gg_select_all_img').hide();
			}
		}, 250);
		
		
		//// track button click
		$(document).delegate('#gg_select_all_img', 'mousedown', function(e) {
			e.stopImmediatePropagation();
			
			if( $(this).hasClass('selected') ) {
				$(this).removeClass('selected').text('<?php esc_html_e('Select all', GG_ML) ?>');
				$('.lcwp_row_to_sel').each(function() {
					$(this).removeClass('lcwp_sel_row');
					$(this).parent().parent().removeClass('selected');
				});
				gg_bulk_opt();
			}
			else {
				if(!$('.lcwp_row_to_sel').length) {return false;}
				
				$(this).addClass('selected').text('<?php esc_html_e('Deselect all', GG_ML) ?>');
				$('.lcwp_row_to_sel').each(function() {
					$(this).addClass('lcwp_sel_row');
					$(this).parent().parent().addClass('selected');
				});
				gg_bulk_opt();
			}
		});
		
		
		// bulk options code
		var gg_bulk_opt = function() {
			var bulk_opt_code = $('#gg_bulk_cmd_code_wrap').html();
	
			if($('#gg_fb_builder li.selected').length) {
				$('#gg_bulk_opt_wrap').empty();
				$('#gg_bulk_opt_wrap').append(bulk_opt_code).fadeIn();
				gg_live_chosen();
				gg_bulk_opt_input_toggle();
			}
			else {
				$('#gg_bulk_opt_wrap').fadeOut(function() {
					$(this).empty();
				});
			}
		}
		
	
		// bulk opt input toggle
		var gg_bulk_opt_input_toggle = function() {
			$(document).delegate('#gg_bulk_opt', 'change', function() {
				if( $(this).val() == 'remove') {
					$('#gg_bulk_val, #gg_bulk_thumb_wrap').fadeOut();
				}
				else if( $(this).val() == 'thumb') {
					$('#gg_bulk_val').val('').fadeOut();
					$('#gg_bulk_thumb_wrap').fadeIn();
				}
				else {
					$('#gg_bulk_val').val('').fadeIn();
					$('#gg_bulk_thumb_wrap').fadeOut();
				}
			});
		}
	
		// perform bulk opt
		$(document).delegate('#gg_bulk_perform', 'click', function() {
			var type = $('#gg_bulk_opt').val();
			var bulk_val = $('#gg_bulk_val').val();
			var new_center = $('#gg_bulk_thumb_val').val();
	
			if(type == 'remove') {
				if(confirm('<?php echo gg_sanitize_input( __('Remove selected images?', GG_ML)) ?>')) {
					$('#gg_fb_builder li.selected').fadeOut(function() {
						$(this).remove();
						gg_sel_picker_img_status();
						gg_count_gall_images();
					});
					gg_reset_selection();
				}
			}
			else if(type == 'thumb') {
				$('#gg_fb_builder li.selected').each(function() {
					$(this).find('.gg_item_thumb').val(new_center);
	
					var img_url =  $(this).find('.gg_builder_img').attr('fullurl');
					var new_thumb_url = TT_url+'?src='+img_url+'&w=400&h=190&q=90&a='+new_center;
					$(this).find('.gg_builder_img').attr('src', new_thumb_url);
				});
	
				gg_reset_selection();
			}
			else {
				if(type == 'author') {
					$('#gg_fb_builder li.selected .gg_item_author').val(bulk_val);
				}
				else if(type == 'title') {
					$('#gg_fb_builder li.selected .gg_item_title').val(bulk_val);
				}
				else if(type == 'descr') {
					$('#gg_fb_builder li.selected .gg_item_descr').val(bulk_val);
				}
	
				gg_reset_selection();
			}
		});
		
	
		// reset items selection
		var gg_reset_selection = function() {
			$('.lcwp_sel_row').each(function() {
				$(this).removeClass('lcwp_sel_row');
				$(this).parent().parent().removeClass('selected');
	
				if($('#gg_select_all_img').hasClass('selected')) {
					$('#gg_select_all_img').removeClass('selected').text("<?php echo gg_sanitize_input( __('select all', GG_ML)) ?>");
				}
				gg_bulk_opt();
			});
		}
	
	
		// status updater for selected images
		var gg_sel_picker_img_status = function() {
			$('.gg_all_img').each(function() {
				var $target = $(this).parent();
				($('.gg_builder_img[fullurl="'+ $(this).attr('fullurl') +'"]').length) ? $target.addClass('gg_img_inserted') : $target.removeClass('gg_img_inserted');
			});
		};
	
	
		// linking management
		$(document).delegate('.gg_img_texts select.gg_linking_dd', 'change', function() {
			var link_opt = $(this).val();
	
			if(link_opt == 'page') {
				var link_field = '<?php echo str_replace("'", "\'", gg_link_field('page')); ?>';
			}
			else if(link_opt == 'custom') {
				var link_field = '<?php echo gg_link_field('custom'); ?>';
			}
			else {
				var link_field = '<?php echo gg_link_field('none'); ?>';
			}
	
			$(this).parent().find('.gg_link_wrap').html(link_field);
		});
	
	
	
		///////////////////////////////////////////////////////////////////////////
	
	
	
		////////////////////////
		// automatic gallery population
	
		// autopop switch behaviours
		$(document).delegate('#gg_autopop input', 'lcs-statuschange', function() {
			if( $(this).is(':checked') ) {
				gg_autopop_make_cache();

				// gallery auto-population toggle
				$('.gg_autopop_fields').slideDown();
				$('#gg_sort_mode, #gg_select_all_img, #gg_img_picker_area').fadeOut();
				
				if($('#gg_sort_mode').hasClass('gg_esm_on')) {$('#gg_sort_mode').trigger('mousedown');}
				if($('#gg_select_all_img').hasClass('selected')) {$('#gg_select_all_img').trigger('mousedown');}
			}
			else {
				$('#gg_builder_wrap').html('<em><?php echo gg_sanitize_input( __('Select images source', GG_ML)) ?></em>');
				gg_sel_picker_img_status();
				$('#gg_sort_mode, #gg_select_all_img, #gg_img_picker_area').fadeIn();
	
				// gallery auto-population toggle
				$('.gg_autopop_fields').slideUp();
			}
		});
	
	
		// re-load on click
		$(document).delegate('.gg_rebuild_cache', 'click', function() {
			gg_autopop_make_cache();
		});
	
		// create the cache and display images in the builder
		var gg_autopop_make_cache = function() {
			var max_img = $('#gg_max_images').val();
			var random_img = ( $('#gg_auto_random input').is(':checked') ) ? 1 : 0;
	
			var data = {
				action: 'gg_make_autopop',
				gg_type			: gg_type,
				gallery_id		: gid,
				gg_extra		: get_type_extra(),
				gg_max_img		: max_img,
				gg_random_img	: random_img,
				gg_erase_past	: gg_erase_past,
				nonce			: gg_nonce,
			};
	
			$('#gg_builder_wrap').html('<div style="height: 30px; margin: 7px 0 3px 15px;" class="lcwp_loading"></div>');
	
			$.post(ajaxurl, data, function(response) {
				$('#gg_builder_wrap').html(response);
				
				gg_count_gall_images();
				gg_read_imgs_data();
	
				if(gg_erase_past) {
					gg_erase_past = false;
				}
			});
	
			return true;
		}

	
	
		/////////////////////////////////////////////////////////////////////////
	
	
	
		// change imges picker's page
		$(document).delegate('.gg_img_pick_back, .gg_img_pick_next', 'click', function() {
			var page = $(this).attr('id').substr(4);
			gg_load_img_picker(page);
		});
	
		// change images per page
		$(document).delegate('#gg_img_pick_pp', 'keyup', function() {
			
			if(typeof(gg_img_picker_tOut) != 'undefined') {
				clearTimeout( gg_img_picker_tOut );	
			}
			var pp = $(this).val();
			
			gg_img_picker_tOut = setTimeout(function() {
				if( pp.length >= 2 ) {
					if( parseInt(pp) < 10 ) {
						$('#gg_img_pick_pp').val(10);
						gg_img_pp = 10;
					}
					else {gg_img_pp = pp;}
	
					gg_load_img_picker(1);
				}
			}, 300);
		});
	
		
		// re-fetch images on search or enter button
		$(document).delegate('.gg_img_search_btn', 'click', function() {
			gg_load_img_picker(1);
		});
		
		$(document).delegate('.gg_img_search', 'keypress', function(e) {
	
			if(e.keyCode === 13){
				e.preventDefault();
				gg_load_img_picker(1);
				
				return false;
			}
			
			// fetch live
			else {
				if(typeof(gg_img_search_tout) != 'undefined') {clearTimeout(gg_img_search_tout);}
				
				gg_img_search_tout = setTimeout(function() {
					gg_load_img_picker(1);
				}, 400);
			}
		});
		

		// "select all" action
		$(document).delegate('.gg_sel_all_btn', 'click', function() {
			$('#gg_img_picker ul li').not('.gg_img_inserted').each(function() {
				$(this).addClass('gg_img_sel');
			});
			gg_man_img_array();
		});
	
	
		// img selection with click
		$(document).delegate('#gg_img_picker ul li figure', 'click', function() {
			if(!$(this).parent().hasClass('gg_img_inserted')) {
				$(this).parent().toggleClass('gg_img_sel');
				gg_man_img_array();
			}
		});
		
	
		// dynamic selection button title
		$(document).delegate('#gg_img_picker ul li', 'hover', function() {
			if ( $(this).hasClass('gg_img_sel') ) { $(this).attr('title', 'Click to unselect'); }
			else if ( $(this).hasClass('gg_img_inserted') ) { $(this).attr('title', 'Image already in the gallery'); }
			else { $(this).attr('title', 'Click to select');}
		});
	
		// selected images array management
		function gg_man_img_array() {
			gg_sel_img = [];
			$('.gg_img_sel').each(function() {
				gg_sel_img.push( $(this).attr('id') );
			});
	
			if( !gg_sel_img.length) { $('#gg_add_img').fadeOut(); }
			else { $('#gg_add_img').fadeIn(); }
		}
	
	
		// reload on category/album change - ask for confirmation
		$(document).delegate('#gg_wp_cat, #gg_cpt_tax_term, #gg_album, #gg_gdrive_album, #gg_onedrive_album, #gg_fb_album, #gg_rml_folder, #gg_ngg_gallery', 'change', function() {
			
			if( !$('.gg_builder_img').length || confirm('<?php echo gg_sanitize_input( __('Current gallery will be erased. Continue?', GG_ML)) ?>')) {
				if( $('#gg_autopop input').is(':checked') ) {
					gg_erase_past = 1;
					gg_autopop_make_cache();
				}
				else {
					gg_load_img_picker(1);
					$('#gg_builder_wrap').html('<em><?php echo gg_sanitize_input( __('Select images source', GG_ML)) ?></em>');
				}
			} else {
				return false;
			}
		});
	
	
		// CPT taxonomy - change subject and reload terms erasing the gallery
		$(document).delegate('#gg_cpt_tax', 'change', function() {
			if( !$('.gg_builder_img').length || confirm('<?php echo gg_sanitize_input( __('Current gallery will be erased. Continue?', GG_ML)) ?>')) {
				var data = {
					action	: 'gg_cpt_tax_change',
					cpt_tax	: $('#gg_cpt_tax').val(),
					nonce	: gg_nonce,
				};
	
				$('#gg_ctp_tax_term_wrap').html('<div style="height: 30px;" class="lcwp_loading"></div>');
	
				$.post(ajaxurl, data, function(response) {
					$('#gg_ctp_tax_term_wrap').html(response);
					gg_live_chosen();
	
					if( $('#gg_autopop input').is(':checked') ) {
						gg_erase_past = 1;
						gg_autopop_make_cache();
					}
					else {
						gg_load_img_picker(1);
						$('#gg_builder_wrap').html('<em><?php echo gg_sanitize_input( __('Select WP images or the images source', GG_ML)) ?></em>');
					}
				});
			} else {
				return false;
			}
		});
	
	
	
		//////////////////////////////////////////////////////////////////////////////
	
	
	
		// images info detection - pass through JS to not weight on server
		var gg_read_imgs_data = function() {
			$('.gg_builder_img').each(function() {
				var $wrap = $(this).parents('li');
				
				if($wrap.find('.gg_img_info').length) {return true;}
				var img_url = $(this).attr('fullurl');
	
				// read weight and mime
				var blob = null;
				var xhr = new XMLHttpRequest();
				xhr.open("GET", img_url);
				xhr.responseType = "blob"; //force the HTTP response, response-type header to be blob
				xhr.onload = function() {
					blob = xhr.response; //xhr.response is now a blob object
					
					// image sizes
					var img = new Image();
					img.onload = function() {
						var sizes = this.width + ' x ' + this.height +'px';
						
						// detect mime
						switch(blob.type) {
							case 'image/png' : var type = 'png'; break;
							case 'image/gif' : var type = 'gif'; break;
							default 		 : var type = 'jpg'; break;	
						}
						
						
						// append img info block
						var $target = ($wrap.find('.gg_cmd_bar').length) ? $wrap.find('.gg_cmd_bar') : $wrap.find('.gg_builder_img'); 
						$target.after('<div class="gg_img_info">\
							<span>'+ bytes_to_human(blob.size) +'</span><span>'+ type +'</span><span>'+ sizes +'</span>\
						</div>');
					}
					img.src = img_url;
				};
				xhr.send();
			});	
		};
	
		var bytes_to_human = function(bytes) {
		   var sizes = ['bytes', 'kb', 'mb', 'gb'];
		   if (bytes == 0) return '0 Byte';
		   var i = parseInt(Math.floor(Math.log(bytes) / Math.log(1024)));
		   return Math.round(bytes / Math.pow(1024, i), 2) + sizes[i];
		};
	
	
	
		//////////////////////////////////////////////////////////////////////////////
	
	
	
		// custom file uploader for wp gallery
		gg_TB = 0;
		var file_frame = false;
	
		// open tb and hide tabs
		$(document).delegate('.gg_TB', 'click', function(e) {
			
			// If the media frame already exists, reopen it.
			if(file_frame){
			  file_frame.open();
			  return;
			}
		
			// Create the media frame
			file_frame = wp.media.frames.file_frame = wp.media({
			  title: "<?php _e('Global Gallery - images management', GG_ML) ?>",
			  button: {
				text: "<?php _e('Back to builder', GG_ML) ?>",
			  },
			  library : {type : 'image'},
			  multiple: false
			});
			
			// if closed or selected - refresh picker
			file_frame.on('close select', function() {
				gg_load_img_picker(1);
				clearInterval(bb_builder_lb_intval);
			});
		
			// turn button into active in any case and simulate closing
			file_frame.on('open', function() {
				bb_builder_lb_intval = setInterval(function() {
					$('.media-button-select').removeAttr('disabled').addClass('bb_builder_lb_btn');
				}, 10)
			});
			$(document).on('click', '.bb_builder_lb_btn', function() {
				file_frame.close();
			});
		
			file_frame.open();
		});
		
		
	
		/////////////////////////////////////////////////////////////////////
	
	
	
		// open thumbnail's center wizard
		$(document).delegate('.gg_sel_thumb', 'click', function() {
			$sel = $(this).parents('li');
			var thumb_center = $(this).find('input').val();
			if(thumb_center.length == 0) { var thumb_center = 'c'; }
	
			var gg_H = 417;
			var gg_W = 480;
			tb_show( 'Thumbnail center', '#TB_inline?height='+gg_H+'&width='+gg_W+'&inlineId=gg_set_thumb_center' );
	
			$('#TB_ajaxContent .gg_sel_thumb_center td').removeClass('thumb_center');
			$('#TB_ajaxContent .gg_sel_thumb_center #gg_'+thumb_center).addClass('thumb_center');
	
			$('#TB_window').css("height", gg_H);
			$('#TB_window').css("width", gg_W);
	
			$('#TB_window').css("top", (($(window).height() - gg_H) / 4) + 'px');
			$('#TB_window').css("left", (($(window).width() - gg_W) / 4) + 'px');
			$('#TB_window').css("margin-top", (($(window).height() - gg_H) / 4) + 'px');
			$('#TB_window').css("margin-left", (($(window).width() - gg_W) / 4) + 'px');
	
		});
	
		// set the thumbnail center
		$(document).delegate('#TB_ajaxContent .gg_sel_thumb_center td', 'click', function() {
			var new_center = $(this).attr('id').substr(3);
	
			$('#TB_ajaxContent .gg_sel_thumb_center td').removeClass('thumb_center');
			$('#TB_ajaxContent .gg_sel_thumb_center #gg_'+new_center).addClass('thumb_center');
	
			$sel.find('.gg_item_thumb').val(new_center);
	
			<?php if(get_option('gg_use_admin_thumbs')) : ?>
			var img_src = encodeURIComponent( $sel.find('.gg_item_img_src').val() );
			var base_script = (gg_use_tt) ? TT_url : EWPT_url;
			var new_thumb_url = base_script +'?src='+img_src+'&w=400&h=220&q=85&rs=3&zc=3&a='+new_center;
	
			$sel.find('.gg_builder_img').attr('src', new_thumb_url);
			<?php endif; ?>
		});
	
	
	
		///////////////////////////////////////////////////////////////
	
	
	
		// live preview link
		<?php
		$preview_pag = get_option('gg_preview_pag');
		if($preview_pag && $gallery) :
			$link = get_permalink($preview_pag);
		?>
			var gg_live_preview = '<div class="misc-pub-section-last">\
				<a href="<?php echo $link; ?>?gg_gid=<?php echo $post->ID; ?>" target="_blank" id="gg_live_preview_link"><?php echo gg_sanitize_input( __('Go to gallery preview', GG_ML)) ?> &raquo;</a></div>';
	
			$('#submitpost').parent().append(gg_live_preview);
			$('#major-publishing-actions').addClass('misc-pub-section');
		<?php endif; ?>
	
	
	
		/////////////////////////////////////////////////////////////////
		
		
		
		// LC lightbox for images preview
		$(document).delegate(".gg_zoom_img, .gg_enlarge_img", 'click', function(e) {
			var obj = [{
				type	: 'image',
				src		: $(this).parents('li').find('figure').attr('fullurl')
			}];
	
			var instance = lc_lightbox(obj, {
				wrap_class		: 'lcl_zoomin_oc',
				max_width		: '85%', // Lightbox maximum width. Use a responsive percent value or an integer for static pixel value
				max_height		: '85%', 
				
				ins_close_pos	: 'corner',
				open_close_time	: 200,
				fading_time		: 0,
			});
			lcl_open(instance, 0); // direct lightbox opening showing first element
		});
	
	

		/////////////////////////////////////



		gg_read_imgs_data();

		// images block sizing - cycle to find proper size
		var opts_width = function() {
			var w = $('#gg_gallery_builder').width();
			
			for(a=7; a>0; a--) {
				if( ((w / a) + 15) > 300 || a == 1 ) {

					var w_code = 'width: '+ (100/a) +'%;';
					var how_many = a;
					break; 	
				}
			}
			
			var border_trick = (how_many > 1) ? '#gg_fb_builder li:not(:nth-child('+ how_many +'n)) {border-right-width: 0;}' : '';
			
			$('#gg_img_opts_width').remove();
			$('head').append('<style id="gg_img_opts_width" type="text/css">#gg_fb_builder li {'+ w_code +'} '+ border_trick +'</style>');
		}
		opts_width();
		
		$(window).resize(function() {
			fp_column_w_to = setTimeout(function() {
				if(typeof(fp_column_w_to) != 'undefined') {clearTimeout(fp_column_w_to);}
				opts_width();
			}, 50);
		});
	


		// numeric fields control
		$(document).on('keyup', '#gg_main_settings .lcwp_sidebox_meta input, #gg_max_images, #gg_img_pick_pp', function(e) {
			var $subj = $(this);
			var val = parseInt($subj.val(), 10);
			
			if(isNaN(val)) {val = 26;}
			else if(val < 1) {val = 1;}
			else if(val > 200) {val = 200;}

			if(typeof(gg_num_field_check) != 'undefined') {
				clearTimeout(gg_num_field_check);	
			}

			gg_num_field_check = setTimeout(function() {
				$subj.val(val);
			}, 150);
		});
		

		// remove subcategories commands
		$('#gg_gall_categories-adder').remove();
	
		
		// auto-resizing textarea
		$.fn.gg_auto_h_textarea = function(strip_newlines) {
			$(this).each(function() {
				var min_val = ($(this).hasClass('gg_item_descr')) ? 50 : 20;
				$( this ).height(min_val).height( $( this )[ 0 ].scrollHeight );
			
				$( this ).off("input").on("input", function(){
					
					if(typeof(strip_newlines) != 'undefined') {
						$(this).val( $(this).val().replace("\n", "") ); // strip new lines
					}	
					$( this ).height(min_val).height( $( this )[ 0 ].scrollHeight );
				} );
			});
		};
		$(document).ready(function() {
            $('textarea.gg_item_descr').gg_auto_h_textarea();
			$('textarea.gg_item_tags').gg_auto_h_textarea(true);
        });
	
	
		// live lcweb switch declare
		gg_ip_checks = function() {
			$('.ip-checkbox').lc_switch('YES', 'NO');
		}
		
	
		// live chosen declare
		gg_live_chosen = function() {
			$('.lcweb-chosen').each(function() {
				var w = $(this).css('width');
				$(this).chosen({width: w});
			});
			$(".lcweb-chosen-deselect").chosen({allow_single_deselect:true});
		}
	});
	</script>

    <?php
	return true;
}