<?php
// CLLBACKD FOR GALLERY BUILDER SIDE BOXES



//////////////////////////
// GALLERY TYPE
function gg_gb_gallery_type() {
	include_once(GG_DIR . '/classes/gg_connections_hub.php');
	global $post;

	$type 		= get_post_meta($post->ID, 'gg_type', true);
	$username 	= get_post_meta($post->ID, 'gg_username', true);
	$psw 		= get_post_meta($post->ID, 'gg_psw', true);
	
	$conn_hub 	= new gg_connection_hub($post->ID);
	$usern_vis 	= (!$type || in_array($type, array_merge($conn_hub->to_consider, array('wp', 'wp_cat', 'cpt_tax', 'gg_album', 'rml', 'ngg')))) ? 'style="display: none;"' : '';

	// Instagram v6.6 retrocompatibility - transform username into board URL
	if($type == 'instagram' && !filter_var($username, FILTER_VALIDATE_URL)) {
		$username = 'https://www.instagram.com/'. $username .'/';	
	}
	?>
    <div class="lcwp_sidebox_meta">
        <div class="misc-pub-section">
          <select name="gg_type" id="gg_type_dd" autocomplete="off">
            <?php
			foreach(gg_types() as $id => $name) {
				if(in_array($id, array('picasa', 'fb'))) {continue;}
				
				$sel = ($id == $type) ? 'selected="selected"' : '';
				echo '<option value="'.$id.'" '.$sel.'>'.$name.'</option>';
			}
			?>
          </select>
        </div>

		<div class="misc-pub-section" id="gg_connect_id_wrap" <?php if(!in_array($type, $conn_hub->to_consider)) {echo 'style="display: none;"';} ?>>
            <?php echo $conn_hub->src_connections_dd(); ?>
        </div>   

        <div class="misc-pub-section" id="gg_username_wrap" <?php echo $usern_vis ?>>
            <label><?php echo gg_username_label($type); ?></label>
            <input type="text" name="gg_username" value="<?php echo gg_sanitize_input($username); ?>" id="gg_username" />
        </div>

        <input type="button" name="gg_handle_user" value="Connect" id="gg_handle_user_btn" class="button-secondary" style="margin-top: 7px;
		<?php if(!$type || in_array($type, array('wp', 'wp_cat', 'cpt_tax', 'gg_album', 'rml', 'ngg'))) {echo 'display: none;';} ?>" />
    </div>
    
    
    <script type="text/javascript">
    // chosen and lc-lightbox enqueued in builder.php file - as well as blocks visibility
	jQuery(document).ready(function($) {
		var gid = <?php echo $post->ID ?>;
		var gg_conn_hub_acting = false;
		var refresh_dd_on_close = false;
		
		
		// lightbox on wizard link click
		$(document).on('click', '#gg_launch_conn_wizard', function(e) {
			e.preventDefault();
			
			var obj = [{
				type	: 'html',
				src		: '#gg_conn_hub_wizard_outer_wrap'
			}];
	
			var instance = lc_lightbox(obj, {
				wrap_class	: 'lcl_zoomin_oc',
				max_width	: 450,
				modal		: true,
				
				ins_close_pos	: 'corner',
				open_close_time	: 250,
				fading_time		: 0,
				animation_time	: 0,
				
				// populate lightbox on open
				on_open	: function () {
					conn_hub_fill_lightbox();
				},
				
				// reload connections dropdown on close
				on_close : function() {
					if(gg_conn_hub_acting) {return false;}
					gg_conn_hub_acting = true;
					
					// if something changed - refresh
					if(refresh_dd_on_close) {
						gg_reload_conn_hub_dd();
					}
				}
			});
			lcl_open(instance, 0); // direct lightbox opening showing first element
		});
		
		
		// populate lightbox
		var conn_hub_fill_lightbox = function() {
			gg_conn_hub_acting = true;

			// populate with ajax
			$('.lcl_html_elem #gg_conn_hub_wizard_wrap').html('<div style="height: 90px; background: url(<?php echo GG_URL ?>/img/loader_big.gif) no-repeat center center transparent;"></div>');
	
			var data = {
				action		: 'gg_connect_wizard_show',
				gg_type		: $('#gg_type_dd').val(),
				gallery_id	: gid,
				nonce		: gg_nonce,
			};
			$.post(ajaxurl, data, function(response) {
				$('.lcl_html_elem #gg_conn_hub_wizard_wrap').html(response);
				gg_conn_hub_acting = false;
			});	
		};
		
		
		// load connections dropdown
		gg_reload_conn_hub_dd = function() {
			// reload connection's dropdown
			$('#gg_connect_id_wrap').html('<div style="width: 20px; height: 20px;" class="lcwp_loading"></div>');
	
			var data = {
				action		: 'gg_connect_dd_reload',
				gg_type		: $('#gg_type_dd').val(),
				gallery_id	: gid,
				nonce		: gg_nonce,
			};
			$.post(ajaxurl, data, function(response) {
				$('#gg_connect_id_wrap').html(response);
				
				gg_live_chosen();
				refresh_dd_on_close = false;
				gg_conn_hub_acting = false;
			});	
		};


		// submit connection trial
		$(document).delegate('#gg_conn_hub_submit', 'click', function() {
			var $subj = $('#gg_add_conn_form');
			$subj.find('section').empty();
			
			// check that every field has been filled up
			var js_check = true;
			$subj.find('input').each(function() {
                if(!$(this).val() && $(this).parents('p').is(':visible')) {
					$subj.find('section').html('<div class="gch_error"><?php _e('One or more fields are empty', GG_ML) ?></div>');
					js_check = false;
					return false;	
				}
            });
			
			if(!js_check || gg_conn_hub_acting) {return false;}
			gg_conn_hub_acting = true;
			
			// ajax submission
			$('#gg_conn_hub_submit').css('opacity', 0.5);

			var data = 'action=gg_save_type_connect&gg_type='+$('#gg_type_dd').val()+'&gallery_id='+gid+'&nonce='+ gg_nonce +'&'+ $subj.serialize();
			$.post(ajaxurl, data, function(response) {
				$('#gg_conn_hub_submit').css('opacity', 1);
				
				if($.trim(response) != 'success') {
					$subj.find('section').html('<div class="gch_error">'+ response +'</div>');	
					gg_conn_hub_acting = false;
				}
				else {
					$subj.find('section').html('<div class="gch_success"><?php _e('Successfully connected!', GG_ML) ?></div>');
					refresh_dd_on_close = true;
					
					// successfully added - reload lightbox contents
					setTimeout(function() {
						conn_hub_fill_lightbox();	
					}, 1700);
				}
			}).fail(function() {
				// handle eventual 500 server errors (eg. dropbox on bad token)
				$subj.find('section').html("<div class='gch_error'><?php _e('Connection error - check credentials', GG_ML) ?></div>");	
				
				$('#gg_conn_hub_submit').css('opacity', 1);
				gg_conn_hub_acting = false;
			});
		});
		
		
		// delete connections
		$(document).on('click', '#gg_conn_hub_wizard_wrap .lcwp_del_row', function(e) {
			if(gg_conn_hub_acting) {return false;}
			var $subj = $(this).parents('tr');
			
			if(confirm("<?php _e("Do you really want to remove this connection?", GG_ML) ?>")) {
				gg_conn_hub_acting = true;
				$(this).parents('tr').fadeTo(100, 0.7);
			
				var data = {
					action	: 'gg_remove_connection',
					conn_id	: $subj.attr('rel'),
					nonce	: gg_nonce,
				};
				$.post(ajaxurl, data, function(response) {
					if($.trim(response) == 'success') {
						$subj.slideUp();
						refresh_dd_on_close = true;	
					} 
					else {
						alert(response);	
					}
					
					gg_conn_hub_acting = false;
				});	
			}
		});
		
    });
    </script>
    
    <?php
	// create a custom nonce for submit verification later
    echo '<input type="hidden" name="gg_gallery_noncename" value="' . wp_create_nonce('gg_gall_builder') . '" />';
	return true;
}






//////////////////////////
// GALLERY MAIN SETTINGS
function gg_gb_main_settings() {
	global $post;

	$layout 		= get_post_meta($post->ID, 'gg_layout', true);
	$thumb_w 		= get_post_meta($post->ID, 'gg_thumb_w', true);
	$thumb_h 		= get_post_meta($post->ID, 'gg_thumb_h', true);
	
	$colnzd_max_w 	= get_post_meta($post->ID, 'gg_colnzd_thumb_max_w', true);
	$colnzd_h 		= get_post_meta($post->ID, 'gg_colnzd_thumb_h', true);
	$colnzd_h_type 	= get_post_meta($post->ID, 'gg_colnzd_thumb_h_type', true);

	$masonry_cols 	= get_post_meta($post->ID, 'gg_masonry_cols', true);
	$masonry_min_w 	= get_post_meta($post->ID, 'gg_masonry_min_width', true);;
	
	$ps_height 		= get_post_meta($post->ID, 'gg_photostring_h', true);
	$ps_min_w 		= get_post_meta($post->ID, 'gg_photostring_min_width', true);

	$paginate 		= get_post_meta($post->ID, 'gg_paginate', true);
	$per_page 		= get_post_meta($post->ID, 'gg_per_page', true);
	
	$orderby 		= get_post_meta($post->ID, 'gg_orderby', true);
	
	if(!$paginate || $paginate == 'default') {
		$per_page = get_option('gg_img_per_page');
	}

	// switches
	$hide = 'style="display: none;"';
	$standard_show 	= ($layout != 'standard') ? $hide : '';
	$columnized_show= ($layout != 'columnized') ? $hide : '';
	$masonry_show 	= ($layout != 'masonry') ? $hide : '';
	
	$ps_show 		= ($layout != 'string') ? $hide :  '';
	$per_page_show 	= ($paginate != '1') ? $hide : '';
	?>
    <div class="lcwp_sidebox_meta lcwp_form">
      <div class="misc-pub-section">
      	<div style="float: right; margin-top: -7px;">
        	<select name="gg_layout" id="gg_layout" autocomplete="off" style="width: 122px;">
                <option value="default"><?php _e('As default', GG_ML) ?></option>
                <option value="standard" <?php selected($layout, 'standard') ?>>Standard</option>
                <option value="columnized" <?php selected($layout, 'columnized') ?>>Columnized</option>
                <option value="masonry" <?php selected($layout, 'masonry') ?>>Masonry</option>
                <option value="string" <?php selected($layout, 'string') ?>>PhotoString</option>
            </select>
        </div>
        
        <label><?php _e('Gallery layout', GG_ML) ?></label>
      </div>


      <div class="misc-pub-section" id="gg_tt_sizes" <?php echo $standard_show; ?>>
		<div style="float: right; margin-top: -5px;">
            <input type="text" name="gg_thumb_w" value="<?php echo $thumb_w ?>" maxlength="4" autocomplete="off" style="width: 42px; margin-right: 3px; text-align: center;" /> x
            <input type="text" name="gg_thumb_h" value="<?php echo $thumb_h ?>" maxlength="4" autocomplete="off" style="width: 42px; margin-left: 3px; text-align: center;" /> px
        </div>
        
        <label><?php _e('Thumbnail sizes', GG_ML) ?></label>
      </div>
      
      <div class="misc-pub-section gg_columnized_fields" <?php echo $columnized_show; ?>>
       <div style="float: right; margin-top: -5px; width: 123px;">
            <input type="number" name="gg_colnzd_thumb_max_w" value="<?php echo $colnzd_max_w ?>" maxlength="3" min="20" autocomplete="off" style="width: 65px; text-align: center;" /> px
        </div>
        
        <label><?php _e('Max thumbs width', GG_ML) ?></label>
      </div>
      <div class="misc-pub-section gg_columnized_fields" <?php echo $columnized_show; ?>>
        <div style="float: right; margin-top: -5px;">
            <input type="number" name="gg_colnzd_thumb_h" value="<?php echo $colnzd_h ?>" maxlength="4" min="20" autocomplete="off" style="width: 65px; margin-right: 3px; text-align: center;" />
            
            <select name="gg_colnzd_thumb_h_type" autocomplete="off" style="width: 50px; min-width: 0px; position: relative; top: -3px;">
                <option value="px">px</option>
                <option value="%" <?php selected($colnzd_h_type, '%') ?>>%</option>
            </select>
        </div>
        
        <label><?php _e('Thumbnails height', GG_ML) ?></label>
      </div>
      
      
      <div class="misc-pub-section gg_masonry_fields" <?php echo $masonry_show; ?>>
        <div style="float: right; margin-top: -3px;">
            <div style="float: right; margin-top: -5px;">
                <select name="gg_masonry_cols" autocomplete="off" style="width: 122px;">
                	<option value="default"><?php _e('As default', GG_ML) ?></option>
					<?php
					for($a=1; $a<=20; $a++) {
						echo '<option value="'.$a.'" '. selected((int)$masonry_cols, $a, false) .'>'.$a.'</option>';
					}
					?>
                </select>
            </div>
        </div>
        
        <label><?php _e('Image columns', GG_ML) ?></label>
      </div>
      
      <div class="misc-pub-section gg_masonry_fields" <?php echo $masonry_show; ?>>
        <div style="float: right; margin-top: -5px; width: 123px;">
            <input type="number" name="gg_masonry_min_width" value="<?php echo $masonry_min_w ?>" maxlength="3" min="40" autocomplete="off" style="width: 65px; text-align: center;" /> px
        </div>
        
        <label><?php _e('Min thumbs width', GG_ML) ?></label>
      </div>
      
      
      <div class="misc-pub-section gg_ps_fields" <?php echo $ps_show; ?>>
        <div style="float: right; margin-top: -3px; width: 123px;">
        	<input type="number" name="gg_photostring_h" value="<?php echo $ps_height ?>" maxlength="4" min="20" autocomplete="off" style="width: 65px; margin-right: 2px; text-align: center;" /> px
        </div>
        
        <label><?php _e('Thumbs height', GG_ML) ?></label>
      </div>
      
      <div class="misc-pub-section gg_ps_fields" <?php echo $ps_show; ?>>
        <div style="float: right; margin-top: -5px; width: 123px;">
            <input type="number" name="gg_photostring_min_width" value="<?php echo $ps_min_w ?>" maxlength="3" min="40" autocomplete="off" style="width: 65px; text-align: center;" /> px
        </div>
        
        <label><?php _e('Min thumbs width', GG_ML) ?></label>
      </div>
      

      <div class="misc-pub-section">
        <div style="float: right; margin-top: -5px;">
        	<select name="gg_paginate" id="gg_paginate" autocomplete="off" style="width: 122px;">
                <option value="default"><?php _e('As default', GG_ML) ?></option>
                <option value="1" <?php selected($paginate, '1') ?>><?php _e('Yes', GG_ML) ?></option>
                <option value="0" <?php selected($paginate, '0') ?>><?php _e('No', GG_ML) ?></option>
            </select>
        </div>
        
        <label><?php _e('Use pagination?', GG_ML) ?></label>
      </div>
      <div class="misc-pub-section-last" id="gg_per_page" <?php echo $per_page_show; ?>>
        <div style="float: right; margin-top: -3px;">
        	<input type="number" name="gg_per_page" value="<?php echo $per_page ?>" maxlength="4" autocomplete="off" style="width: 65px; margin-right: 56px; text-align: center;" />
        </div>
        
         <label><?php _e('Images per page', GG_ML) ?></label>
      </div>
      
      
      <div class="misc-pub-section">
        <div style="float: right; margin-top: -5px;">
        	<select name="gg_orderby" autocomplete="off" style="width: 122px;">
                <option value="default"><?php _e('As in builder', GG_ML) ?></option>
                <option value="title_asc" <?php selected($orderby, 'title_asc') ?>><?php _e('By title (A to Z)', GG_ML) ?></option>
                <option value="title_desc" <?php selected($orderby, 'title_desc') ?>><?php _e('By title (Z to A)', GG_ML) ?></option>
                <option value="author_asc" <?php selected($orderby, 'author_asc') ?>><?php _e('By author (A to Z)', GG_ML) ?></option>
                <option value="author_desc" <?php selected($orderby, 'author_desc') ?>><?php _e('By author (Z to A)', GG_ML) ?></option>
                <option value="id_asc" <?php selected($orderby, 'id_asc') ?>><?php _e('By date (A to Z)', GG_ML) ?></option>
                <option value="id_desc" <?php selected($orderby, 'id_desc') ?>><?php _e('By date (Z to A)', GG_ML) ?></option>
            </select>
        </div>
        
        <label><?php _e('Images sorting', GG_ML) ?></label>
      </div>
    </div>


	<script type="text/javascript">
	jQuery(document).ready(function($) {
        
		// main settings toggle
		$(document).delegate('#gg_layout', 'change', function() {
			var layout = $(this).val();

			if(layout == 'standard') {
				$('#gg_tt_sizes').show();
				$('.gg_columnized_fields, .gg_masonry_fields, .gg_ps_fields').hide();
			}
			else if (layout == 'columnized') {
				$('.gg_columnized_fields').show();
				$('#gg_tt_sizes, .gg_masonry_fields, .gg_ps_fields').hide();
			}
			else if (layout == 'masonry') {
				$('.gg_masonry_fields').show();
				$('.gg_columnized_fields, #gg_tt_sizes, .gg_ps_fields').hide();
			}
			else if (layout == 'string') {
				$('.gg_ps_fields').show();
				$('#gg_tt_sizes, .gg_masonry_fields').hide();
			}
			else { 
				$('#gg_tt_sizes, .gg_columnized_fields, .gg_masonry_fields, .gg_ps_fields').hide(); 
			}
		});

		
		// paginate toggle
		$(document).delegate('#gg_paginate', 'change', function() {	
			($(this).val() == '1') ? $('#gg_per_page').fadeIn() : $('#gg_per_page').fadeOut();
		});
		
		
		// toggle WP-restricted sorting
		$(document).delegate('#gg_type_dd', 'change', function() {
			
			switch($(this).val()) {
				case 'wp' :
				case 'wp_cat' :
				case 'cpt_tax' :
				case 'rml' :
					$('select[name=gg_orderby]').find('option[value="id_asc"], option[value="id_desc"]').removeAttr('disabled');
					break;  
				
				default :
					$('select[name=gg_orderby]').find('option[value="id_asc"], option[value="id_desc"]').prop('disabled', 'disabled');
					break;  
			}
		});
		$('#gg_layout').trigger('change'); // on init
    });
	</script>
    <?php
	return true;
}






//////////////////////////
// PAGE URL FOR SITEMAP
function gg_gb_sitemap() {
	global $post;
	$type = get_post_meta($post->ID, 'gg_type', true);
	
	// only for local images
	if(!$type || !in_array($type, array('wp', 'wp_cat', 'cpt_tax', 'gg_album', 'rml', 'ngg'))) {
		?>
        <style type="text/css">
		#gg_gb_sitemap {
			display: none;	
		}
		</style>
        <?php
		return false;
	}
	
	$url = get_post_meta($post->ID, 'gg_sitemap_page_url', true);
	?>
    <div class="lcwp_sidebox_meta">
        <div class="misc-pub-section">
            <input type="text" name="gg_sitemap_page_url" value="<?php echo esc_attr($url) ?>" placeholder="<?php echo site_url() ?> ..." />
        </div>
    </div>
    
    <script type="text/javascript">
	jQuery(document).ready(function($) {
        $('#gg_type_dd').on('change', function() {
			( $.inArray($(this).val(), ['wp', 'wp_cat', 'cpt_tax', 'gg_album', 'rml', 'ngg']) !== -1) ? $('#gg_gb_sitemap').slideDown() : $('#gg_gb_sitemap').slideUp(); 
		});
    });
	</script>
    <?php
}








//////////////////////////
// CREATE WATERMARK CACHE
function gg_gb_wmark_cache() {
	global $post;
	if(gg_get_gall_first_img($post->ID, 'img')) :
	?>
    <div class="lcwp_mainbox_meta">
    	<div>
        	<a href="javascript:void(0)" style="text-decoration: none;">
            	<i class="dashicons dashicons-shield"></i> <?php _e('Create watermark cache', GG_ML) ?>
            </a> 
            <span></span>
    	</div>
    </div>

    <script type="text/javascript">
	jQuery(document).ready(function($) {
		var $wmark_box = $('#gg_gb_wmark_cache .lcwp_mainbox_meta > div');
		
		$(document).delegate('#gg_gb_wmark_cache .lcwp_mainbox_meta a', 'click', function(e) {
			e.preventDefault();
			$wmark_box.find('small, div').remove();
			
			//$wmark_box.find('div').remove(); // clean past results
			$wmark_box.find('span').html('<div style="width: 20px; height: 20px;" class="lcwp_loading"></div>');
			$wmark_box.append('<small style="padding-left: 15px;">(<?php echo gg_sanitize_input( __('might take very long if you have many images to manage', GG_ML)) ?>)</small>');

			var data = {
				action	: 'gg_create_wm_cache',
				gid		: <?php echo $post->ID ?>,
				nonce	: gg_nonce,
			};
			$.post(ajaxurl, data, function(response) {
				var resp = $.trim(response);

				$wmark_box.find('span').empty();
				$wmark_box.find('small').remove();

				if(resp == 'success') {
					$wmark_box.append('<div><?php echo gg_sanitize_input( __('Cache created succesfully', GG_ML)) ?>!</div>');
				}
				else {
					console.error(resp);
					
					if(resp.indexOf("Maximum execution") != -1) {
						$wmark_box.append('<div><?php _e('Process took too much time for your server. Try again', GG_ML ) ?></div>');
					}
					else if(resp.indexOf("bytes exhausted") != -1) {
						$wmark_box.append('<div><?php _e('The process requires too much memory for your server. Try using smaller images', GG_ML ) ?></div>');
					}
					else {
						$wmark_box.append('<div><?php _e('Error during the cache creation', GG_ML ) ?></div>');
					}
				}
			}).fail(function(xhr, status, error) {
        		console.error(error);
    		});;
		});
	});
	</script>

    <style type="text/css">
	#gg_create_gall_wmark_cache {display: block;}
	</style>
    <?php else : ?>

    <style type="text/css">
	#gg_create_gall_wmark_cache {display: none;}
	</style>

    <?php endif;
}