<?php
/* 
Plugin Name: Global Gallery
Plugin URI: https://lcweb.it/global-gallery
Description: Easily display photos on your website with style. Catch images from socials or use WP ones. Finally design your galleries, choose the lightbox and protect them with watermark.
Author: پرشین اسکریپت
Version: 7.051
Author URI: https://persianscript.ir
*/  


/////////////////////////////////////////////
/////// MAIN DEFINES ////////////////////////
/////////////////////////////////////////////

// plugin path
$wp_plugin_dir = substr(plugin_dir_path(__FILE__), 0, -1);
define('GG_DIR', $wp_plugin_dir);

// plugin url
$wp_plugin_url = substr(plugin_dir_url(__FILE__), 0, -1);
define('GG_URL', $wp_plugin_url);


// timthumb url - also for MU
if(is_multisite()){ define('GG_TT_URL', GG_URL . '/classes/timthumb_MU.php'); }
else { define('GG_TT_URL', GG_URL . '/classes/timthumb.php'); }


// Global Gallery albums basepath
$path = $wp_plugin_dir . '/albums';
define('GGA_DIR', $path);

// Global Gallery albums baseurl
$url = $wp_plugin_url . '/albums';
define('GGA_URL', $url);



// multilang key
define('GG_ML', 'gg_ml');

// plugin version
define('GG_VER', '7.051a');




/////////////////////////////////////////////
/////// FORCING DEBUG ///////////////////////
/////////////////////////////////////////////

if(isset($_REQUEST['gg_php_debug'])) {
	ini_set('display_errors', 1);
	ini_set('display_startup_errors', 1);
	error_reporting(E_ALL);	
}





/////////////////////////////////////////////
/////// MULTILANGUAGE SUPPORT ///////////////
/////////////////////////////////////////////

function gg_multilanguage() {
  $param_array = explode(DIRECTORY_SEPARATOR, GG_DIR);
  $folder_name = end($param_array);
  
  if(is_admin()) {
	 load_plugin_textdomain( GG_ML, false, $folder_name . '/lang_admin');  
  } else {
	 load_plugin_textdomain( GG_ML, false, $folder_name . '/languages');  
  }
}
add_action('init', 'gg_multilanguage', 1);





/////////////////////////////////////////////
/////// MAIN SCRIPT & CSS INCLUDES //////////
/////////////////////////////////////////////


// global script enqueuing
function gg_admin_scripts() {
	wp_enqueue_style('gg_admin', GG_URL . '/css/admin.css', 999, GG_VER);
	wp_enqueue_style('gg_settings', GG_URL . '/settings/settings_style.css', 999, GG_VER);	
	
	// chosen
	wp_enqueue_style( 'lcwp-chosen-style', GG_URL.'/js/chosen/chosen.css', 999);
	
	// lcweb switch
	wp_enqueue_style( 'lc-switch', GG_URL.'/js/lc-switch/lc_switch.css', 999);
	
	// colorpicker
	wp_enqueue_style( 'gg-colpick', GG_URL.'/js/colpick/css/colpick.css', 999);
	
	
	wp_enqueue_script('jquery-ui-sortable');
	wp_enqueue_script('jquery-ui-slider');
	
	
	// lightbox and thickbox
	if(function_exists('wp_enqueue_media')) {
		wp_enqueue_media();	
	}
	wp_enqueue_style('thickbox');
	wp_enqueue_script('thickbox');
	
	wp_enqueue_style('gg_fontawesome', GG_URL . '/css/font-awesome/css/font-awesome.min.css', 999, '4.7.0');
}
add_action('admin_enqueue_scripts', 'gg_admin_scripts');



function gg_global_scripts() {
	wp_enqueue_script('jquery');
	wp_enqueue_style('gg_fontawesome', GG_URL . '/css/font-awesome/css/font-awesome.min.css', 999, '4.7.0');
	
	// frontent JS on header or footer
	if(!get_option('gg_js_head')) {
		wp_enqueue_script('gg-frontend-js', GG_URL . '/js/frontend.js', 999, GG_VER, true);
	}
	else { wp_enqueue_script('gg-frontend-js', GG_URL . '/js/frontend.js', 99, GG_VER); }
	
	
	// frontend css
	wp_enqueue_style('gg-frontend-css', GG_URL. '/css/frontend.min.css', 90, GG_VER);	
	wp_enqueue_style('gg-slider-css', GG_URL. '/js/jquery.galleria/themes/ggallery/galleria.ggallery_minimal.css', 92, GG_VER);
	
	// custom CSS
	if(!get_option('gg_inline_css') && !get_option('gg_force_inline_css')) {
		wp_enqueue_style('gg-custom-css', GG_URL. '/css/custom.css', 100, GG_VER .'-'. get_option('gg_dynamic_scripts_id'));	
	}
	else {add_action('wp_head', 'gg_inline_css', 999);}
}
add_action('wp_enqueue_scripts', 'gg_global_scripts', 900);
add_action('lc_guten_scripts', 'gg_global_scripts');



// USE FRONTEND CSS INLINE
function gg_inline_css(){
	if(isset($GLOBALS['gg_printed_inline_css'])) { // avoid double enqueuing with Gutenberg
		return false;	
	}
	$GLOBALS['gg_printed_inline_css'] = true;
	
	echo '<style type="text/css">';
	require_once(GG_DIR.'/frontend_css.php');
	echo '</style>';
}




/////////////////////////////////////////////
/////// MAIN INCLUDES ///////////////////////
/////////////////////////////////////////////

// admin menu and cpt and taxonomy
include_once(GG_DIR .'/functions.php');

// admin menu and cpt and taxonomy
include_once(GG_DIR .'/admin_menu.php');

// gallery taxonomy options
include_once(GG_DIR .'/taxonomy_options.php');

// connection hub taxonomy
include_once(GG_DIR .'/connect_hub_tax.php');

// gallery builder
include_once(GG_DIR .'/gallery_builder/builder.php');

// wp galleries management
include_once(GG_DIR .'/wp_gallery_manag.php');

// tinymce integration
include_once(GG_DIR .'/tinymce_integration.php');

// admin ajax
include_once(GG_DIR .'/admin_ajax.php');

// direct image share hack 
include_once(GG_DIR .'/classes/lc_social_img_share_metas.php');

// frontend ajax
include_once(GG_DIR .'/front_ajax.php');

// dynamic footer javascript
include_once(GG_DIR .'/dynamic_js.php');

// gallery previews
include_once(GG_DIR .'/gallery_preview.php');

// lightboxes switch
include_once(GG_DIR .'/lightboxes.php');

// deeplinks retrieval
include_once(GG_DIR .'/deeplinks_retrieval.php');


// SHORTCODES
include_once(GG_DIR .'/shortcodes/gallery.php');
include_once(GG_DIR .'/shortcodes/image-to-gallery.php');
include_once(GG_DIR .'/shortcodes/collection.php');
include_once(GG_DIR .'/shortcodes/slider.php');
include_once(GG_DIR .'/shortcodes/carousel.php');



// Gutenberg integration
include_once(GG_DIR .'/builders_integration/gutenberg.php');

// visual composer integration
include_once(GG_DIR .'/builders_integration/visual_composer.php');

// cornerstone integration
include_once(GG_DIR .'/builders_integration/cornerstone.php');

// elementor integration
include_once(GG_DIR .'/builders_integration/elementor.php');





////////////
// AVOID issues with bad servers in settings redirect
function gg_settings_redirect_trick() {
	ob_start();
}
add_action('admin_init', 'gg_settings_redirect_trick', 1);
////////////





////////////
// EASY WP THUMBS + forcing system
function gg_ewpt() {
	if(get_option('gg_ewpt_force')) {
		$_REQUEST['ewpt_force'] = true;
		define('GG_EWPT_URL', GG_URL . '/classes/easy_wp_thumbs_force.php');
	} else {
		define('GG_EWPT_URL', GG_URL . '/classes/easy_wp_thumbs.php');
	}
	
	include_once(GG_DIR .'/classes/easy_wp_thumbs.php');	
}
add_action('init', 'gg_ewpt', 1);
////////////






////////////
// DOCUMENTATION'S LINK	
function gg_doc_link($links, $file) {
	if($file == plugin_basename(__FILE__)) {	
		$links['lc_doc_link'] = '<a href="https://doc.lcweb.it/global_gallery" target="_blank">'. __('Documentation', GG_ML) .'</a>';
	}
	
	return $links;
}
add_filter('plugin_row_meta', 'gg_doc_link', 50, 2);
////////////



////////////
// AUTO UPDATE DELIVER
include_once(GG_DIR .'/classes/lc_plugin_auto_updater.php');
function gg_auto_updates() {
	if(!get_option('gg_no_auto_upd')) {
		$upd = new lc_wp_autoupdate(__FILE__, 'http://updates.lcweb.it', 'lc_updates', 'gg_init_custom_css', true);
	}
}
add_action('admin_init', 'gg_auto_updates', 1);
////////////







/////////////////////////////////////////////
////// ACTIONS ON PLUGIN ACTIVATION /////////
/////////////////////////////////////////////

function gg_init_custom_css() {

	// create custom CSS
	if(!gg_create_frontend_css()) {
		if(!get_option('gg_inline_css')) {update_option('gg_inline_css', 1);}
	}
	else {delete_option('gg_inline_css');}
	
	
	// connections creation (for versions < 5.0)
	gg_setup_connections_v5();
	
	// setup galleries utility metas and clean old watermark cache in V6 
	gg_v6_setup();
	
	
	// update 5.3 - check old inf_scroll option
	if(get_option('gg_infinite_scroll')) {
		update_option('gg_pag_system', 'inf_scroll');
		delete_option('gg_infinite_scroll');
	}
}
register_activation_hook(__FILE__, 'gg_init_custom_css');




// get galleries data to setup connections for v5.0
function gg_setup_connections_v5() {
	if(!get_option('gg_v5_update_done')) {
		include_once(GG_DIR .'/classes/gg_connections_hub.php');
		
		// retrieve all galleries
		$args = array(
			'numberposts' => -1, 
			'post_type' => 'gg_galleries',
		);
		$posts_array = get_posts($args);
		
		if(is_array($posts_array)) {
			gg_conn_taxonomy(); // be sure taxonomy is registered
			
			foreach($posts_array as $post) {
				$gid = $post->ID;
				
				$ch = new gg_connection_hub($gid);
				if($ch->src == 'g_drive' || !in_array($ch->src, $ch->to_consider)) {continue;}
			
				if(isset($force_continue) && $force_continue) {
					$force_continue = false;
					continue;		
				}
				
				
				// create connection
				if(!empty($ch->ajax_data)) {
					// check against already created connections for this source
					if($term = get_term_by('name', $ch->ajax_data['conn_name'], 'gg_connect_hub')) {
						update_post_meta($gid, 'gg_connect_id', $term->term_id);
					}
					else {
						$result = $ch->save_connection();
						if($result === true) {
							update_post_meta($gid, 'gg_connect_id', $ch->connect_id);	
						}
					}
				}
				$ch->ajax_data = array(); // reset
			}
		}
		
		update_option('gg_v5_update_done', 1);
	}
}


// setup galleries utility metas and clean old watermark cache in V6 
function gg_v6_setup() {
	
	if(!get_option('gg_v6_update_done')) {

		// retrieve all galleries
		$args = array(
			'numberposts' 	=> -1, 
			'post_type' 	=> 'gg_galleries',
			'post_status'	=> 'any',
			'fields' 		=> 'ids'
		);
		$gallery_ids = get_posts($args);
		
		if(is_array($gallery_ids)) {
			
			foreach($gallery_ids as $gid) {
				$autopop = get_post_meta($gid, 'gg_autopop', true);
				
				$images = gg_gall_data_get($gid, $autopop);	
				gg_gall_data_save($gid, $images ,$autopop);
			}
		}
		
		
		// remove old watermarked images from cache folder
		$cache_dir = GG_DIR .'/cache';
		
		foreach(scandir($cache_dir) as $file) {
			if(strpos($file, 'gg_watermark') !== false) {
				@unlink($cache_dir.'/'.$file);	
			}
		}

		update_option('gg_v6_update_done', 1);
	}
}


			